package com.sun.jmx.snmp.agent;

import java.util.Enumeration;
import com.sun.jmx.snmp.SnmpOid;
import java.util.Vector;
import java.io.Serializable;

public class SnmpIndex implements Serializable
{
    private static final long serialVersionUID = 8712159739982192146L;
    private Vector<SnmpOid> oids;
    private int size;
    
    public SnmpIndex(SnmpOid[] array) {
        this.oids = new Vector();
        this.size = 0;
        this.size = array.length;
        for (int i = 0; i < this.size; ++i) {
            this.oids.addElement(array[i]);
        }
    }
    
    public SnmpIndex(SnmpOid obj) {
        this.oids = new Vector();
        this.size = 0;
        this.oids.addElement(obj);
        this.size = 1;
    }
    
    public int getNbComponents() {
        return this.size;
    }
    
    public Vector<SnmpOid> getComponents() {
        return this.oids;
    }
    
    public boolean equals(SnmpIndex snmpIndex) {
        if (this.size != snmpIndex.getNbComponents()) {
            return false;
        }
        Vector<SnmpOid> components = snmpIndex.getComponents();
        int i = 0;
        while (i < this.size) {
            if (!((SnmpOid)this.oids.elementAt(i)).equals((Object)components.elementAt(i))) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public int compareTo(SnmpIndex snmpIndex) {
        int nbComponents = snmpIndex.getNbComponents();
        Vector<SnmpOid> components = snmpIndex.getComponents();
        int i = 0;
        while (i < this.size) {
            if (i > nbComponents) {
                return 1;
            }
            int compareTo = ((SnmpOid)this.oids.elementAt(i)).compareTo((SnmpOid)components.elementAt(i));
            if (compareTo == 0) {
                ++i;
            }
            else {
                return compareTo;
            }
        }
        return 0;
    }
    
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        Enumeration<SnmpOid> elements = this.oids.elements();
        while (elements.hasMoreElements()) {
            sb.append("//").append(((SnmpOid)elements.nextElement()).toString());
        }
        return sb.toString();
    }
}
